Index: uspace/lib/c/generic/vfs/vfs.c
===================================================================
--- uspace/lib/c/generic/vfs/vfs.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/vfs/vfs.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -86,5 +86,5 @@
  * and consume system resources.
  *
- * Functions that return errno_t return an error code on error and do not
+ * Functions that return int return an error code on error and do not
  * set errno. Depending on function, success is signalled by returning either
  * EOK or a non-negative file handle.
@@ -97,5 +97,5 @@
  * 	if (file < 0)
  * 		return file;
- * 	errno_t rc = vfs_open(file, MODE_READ);
+ * 	int rc = vfs_open(file, MODE_READ);
  * 	if (rc != EOK) {
  * 		(void) vfs_put(file);
@@ -128,5 +128,5 @@
 static int root_fd = -1;
 
-static errno_t get_parent_and_child(const char *path, int *parent, char **child)
+static int get_parent_and_child(const char *path, char **child)
 {
 	size_t size;
@@ -136,18 +136,14 @@
 
 	char *slash = str_rchr(apath, L'/');
+	int parent;
 	if (slash == apath) {
-		*parent = vfs_root();
-		if (*parent < 0) {
-			free(apath);
-			return EBADF;
-		}
+		parent = vfs_root();
 		*child = apath;
-		return EOK;
 	} else {
 		*slash = '\0';
-		errno_t rc = vfs_lookup(apath, WALK_DIRECTORY, parent);
-		if (rc != EOK) {
+		parent = vfs_lookup(apath, WALK_DIRECTORY);
+		if (parent < 0) {
 			free(apath);
-			return rc;
+			return parent;
 		}
 		*slash = '/';
@@ -155,11 +151,10 @@
 		free(apath);
 		if (!*child) {
-			vfs_put(*parent);
+			vfs_put(parent);
 			return ENOMEM;
 		}
-
-		return rc;
-	}
-
+	}
+
+	return parent;
 }
 
@@ -236,19 +231,12 @@
  *                      handle will be allocated from high indices
  *
- * @return              New file handle on success or an error code
- */
-errno_t vfs_clone(int file_from, int file_to, bool high, int *handle)
-{
-	assert(handle != NULL);
-
+ * @return              New file handle on success or a negative error code
+ */
+int vfs_clone(int file_from, int file_to, bool high)
+{
 	async_exch_t *vfs_exch = vfs_exchange_begin();
-	sysarg_t ret;
-	errno_t rc = async_req_3_1(vfs_exch, VFS_IN_CLONE, (sysarg_t) file_from,
-	    (sysarg_t) file_to, (sysarg_t) high, &ret);
+	int rc = async_req_3_0(vfs_exch, VFS_IN_CLONE, (sysarg_t) file_from,
+	    (sysarg_t) file_to, (sysarg_t) high);
 	vfs_exchange_end(vfs_exch);
-
-	if (rc == EOK) {
-		*handle = ret;
-	}
 	return rc;
 }
@@ -259,7 +247,7 @@
  * @param size          Size of @a buf
  *
- * @return              EOK on success or a non-error code
- */
-errno_t vfs_cwd_get(char *buf, size_t size)
+ * @return              EOK on success or a non-negative error code
+ */
+int vfs_cwd_get(char *buf, size_t size)
 {
 	fibril_mutex_lock(&cwd_mutex);
@@ -280,7 +268,7 @@
  * @param path  Path of the new working directory
  *
- * @return      EOK on success or an error code
- */
-errno_t vfs_cwd_set(const char *path)
+ * @return      EOK on success or a negative error code
+ */
+int vfs_cwd_set(const char *path)
 {
 	size_t abs_size;
@@ -289,9 +277,8 @@
 		return ENOMEM;
 	
-	int fd;
-	errno_t rc = vfs_lookup(abs, WALK_DIRECTORY, &fd);
-	if (rc != EOK) {
+	int fd = vfs_lookup(abs, WALK_DIRECTORY);
+	if (fd < 0) {
 		free(abs);
-		return rc;
+		return fd;
 	}
 	
@@ -352,7 +339,7 @@
 async_sess_t *vfs_fd_session(int file, iface_t iface)
 {
-	vfs_stat_t stat;
-	errno_t rc = vfs_stat(file, &stat);
-	if (rc != EOK)
+	struct stat stat;
+	int rc = vfs_stat(file, &stat);
+	if (rc != 0)
 		return NULL;
 	
@@ -370,10 +357,10 @@
  * @param info    Place to store volume identification information
  *
- * @return                      EOK on success or an error code
- */
-errno_t vfs_fsprobe(const char *fs_name, service_id_t serv,
+ * @return                      EOK on success or a negative error code
+ */
+int vfs_fsprobe(const char *fs_name, service_id_t serv,
     vfs_fs_probe_info_t *info)
 {
-	errno_t rc;
+	sysarg_t rc;
 	
 	ipc_call_t answer;
@@ -404,7 +391,7 @@
  *        fstypes->fstypes[0..]. To free the list use vfs_fstypes_free().
  *
- * @return                      EOK on success or an error code
- */
-errno_t vfs_fstypes(vfs_fstypes_t *fstypes)
+ * @return                      EOK on success or a negative error code
+ */
+int vfs_fstypes(vfs_fstypes_t *fstypes)
 {
 	sysarg_t size;
@@ -414,5 +401,5 @@
 
 	async_exch_t *exch = vfs_exchange_begin();
-	errno_t rc = async_req_0_1(exch, VFS_IN_FSTYPES, &size);
+	int rc = async_req_0_1(exch, VFS_IN_FSTYPES, &size);
 
 	if (rc != EOK) {
@@ -499,13 +486,13 @@
  * @param[out] linkedfd If not NULL, will receive a file handle to the linked
  *                      child
- * @return              EOK on success or an error code
- */
-errno_t vfs_link(int parent, const char *child, vfs_file_kind_t kind, int *linkedfd)
+ * @return              EOK on success or a negative error code
+ */
+int vfs_link(int parent, const char *child, vfs_file_kind_t kind, int *linkedfd)
 {
 	int flags = (kind == KIND_DIRECTORY) ? WALK_DIRECTORY : WALK_REGULAR;
-	int file = -1;
-	errno_t rc = vfs_walk(parent, child, WALK_MUST_CREATE | flags, &file);
-	if (rc != EOK)
-		return rc;
+	int file = vfs_walk(parent, child, WALK_MUST_CREATE | flags);
+
+	if (file < 0)
+		return file;
 
 	if (linkedfd)
@@ -529,20 +516,19 @@
  * @param[out] linkedfd If not NULL, will receive a file handle to the linked
  *                      child
- * @return              EOK on success or an error code
- */
-errno_t vfs_link_path(const char *path, vfs_file_kind_t kind, int *linkedfd)
+ * @return              EOK on success or a negative error code
+ */
+int vfs_link_path(const char *path, vfs_file_kind_t kind, int *linkedfd)
 {
 	char *child;
-	int parent;
-	errno_t rc = get_parent_and_child(path, &parent, &child);
-	if (rc != EOK)
-		return rc;
-
-	rc = vfs_link(parent, child, kind, linkedfd);
+	int parent = get_parent_and_child(path, &child);
+	if (parent < 0)
+		return parent;
+
+	int rc = vfs_link(parent, child, kind, linkedfd);
 
 	free(child);
 	vfs_put(parent);
 	return rc;
-}
+}	
 
 /** Lookup a path relative to the local root
@@ -550,9 +536,9 @@
  * @param path  Path to be looked up
  * @param flags Walk flags
- * @param[out] handle Pointer to variable where handle is to be written.
- *
- * @return      EOK on success or an error code.
- */
-errno_t vfs_lookup(const char *path, int flags, int *handle)
+ *
+ * @return      File handle representing the result on success or a negative
+ *              error code on error
+ */
+int vfs_lookup(const char *path, int flags)
 {
 	size_t size;
@@ -560,5 +546,4 @@
 	if (!p)
 		return ENOMEM;
-
 	int root = vfs_root();
 	if (root < 0) {
@@ -566,9 +551,5 @@
 		return ENOENT;
 	}
-
-	// XXX: Workaround for GCC diagnostics.
-	*handle = -1;
-
-	errno_t rc = vfs_walk(root, p, flags, handle);
+	int rc = vfs_walk(root, p, flags);
 	vfs_put(root);
 	free(p);
@@ -583,23 +564,20 @@
  * @param flags Walk flags
  * @param mode  Mode in which to open file in
- * @param[out] handle Pointer to variable where handle is to be written.
- *
- * @return      EOK on success or an error code
- */
-errno_t vfs_lookup_open(const char *path, int flags, int mode, int *handle)
-{
-	int file;
-	errno_t rc = vfs_lookup(path, flags, &file);
-	if (rc != EOK)
-		return rc;
-
-	rc = vfs_open(file, mode);
+ *
+ * @return      EOK on success or a negative error code
+ */
+int vfs_lookup_open(const char *path, int flags, int mode)
+{
+	int file = vfs_lookup(path, flags);
+	if (file < 0)
+		return file;
+
+	int rc = vfs_open(file, mode);
 	if (rc != EOK) {
 		vfs_put(file);
 		return rc;
 	}
-
-	*handle = file;
-	return EOK;
+	
+	return file;
 }
 
@@ -614,10 +592,10 @@
  * @param[out] mountedfd        File handle of the mounted root if not NULL
  *
- * @return                      EOK on success or an error code
- */
-errno_t vfs_mount(int mp, const char *fs_name, service_id_t serv, const char *opts,
+ * @return                      EOK on success or a negative error code
+ */
+int vfs_mount(int mp, const char *fs_name, service_id_t serv, const char *opts,
     unsigned int flags, unsigned int instance, int *mountedfd)
 {
-	errno_t rc, rc1;
+	sysarg_t rc, rc1;
 	
 	if (!mountedfd)
@@ -658,7 +636,7 @@
  * @param[in] instance          Instance number of the file system server
  *
- * @return                      EOK on success or an error code
- */
-errno_t vfs_mount_path(const char *mp, const char *fs_name, const char *fqsn,
+ * @return                      EOK on success or a negative error code
+ */
+int vfs_mount_path(const char *mp, const char *fs_name, const char *fqsn,
     const char *opts, unsigned int flags, unsigned int instance)
 {
@@ -685,5 +663,5 @@
 	
 	service_id_t service_id;
-	errno_t res = loc_service_get_id(fqsn, &service_id, flags);
+	int res = loc_service_get_id(fqsn, &service_id, flags);
 	if (res != EOK) {
 		if (null_id != -1)
@@ -704,5 +682,5 @@
 	fibril_mutex_lock(&root_mutex);
 	
-	errno_t rc;
+	int rc;
 	
 	if (str_cmp(mpa, "/") == 0) {
@@ -729,10 +707,11 @@
 		}
 		
-		int mpfd;
-		rc = vfs_walk(root_fd, mpa, WALK_DIRECTORY, &mpfd);
-		if (rc == EOK) {
+		int mpfd = vfs_walk(root_fd, mpa, WALK_DIRECTORY);
+		if (mpfd >= 0) {
 			rc = vfs_mount(mpfd, fs_name, service_id, opts, flags,
 			    instance, NULL);
 			vfs_put(mpfd);
+		} else {
+			rc = mpfd;
 		}
 	}
@@ -743,5 +722,5 @@
 		loc_null_destroy(null_id);
 	
-	return (errno_t) rc;
+	return (int) rc;
 }
 
@@ -752,10 +731,10 @@
  * @param mode  Mode in which to open file in
  *
- * @return      EOK on success or an error code
- */
-errno_t vfs_open(int file, int mode)
-{
-	async_exch_t *exch = vfs_exchange_begin();
-	errno_t rc = async_req_2_0(exch, VFS_IN_OPEN, file, mode);
+ * @return      EOK on success or a negative error code
+ */
+int vfs_open(int file, int mode)
+{
+	async_exch_t *exch = vfs_exchange_begin();
+	int rc = async_req_2_0(exch, VFS_IN_OPEN, file, mode);
 	vfs_exchange_end(exch);
 	
@@ -769,7 +748,7 @@
  * @param exch          Exchange to the acceptor
  *
- * @return              EOK on success or an error code
- */
-errno_t vfs_pass_handle(async_exch_t *vfs_exch, int file, async_exch_t *exch)
+ * @return              EOK on success or a negative error code
+ */
+int vfs_pass_handle(async_exch_t *vfs_exch, int file, async_exch_t *exch)
 {
 	return async_state_change_start(exch, VFS_PASS_HANDLE, (sysarg_t) file,
@@ -781,10 +760,10 @@
  * @param file  File handle to put
  *
- * @return      EOK on success or an error code
- */
-errno_t vfs_put(int file)
-{
-	async_exch_t *exch = vfs_exchange_begin();
-	errno_t rc = async_req_1_0(exch, VFS_IN_PUT, file);
+ * @return      EOK on success or a negative error code
+ */
+int vfs_put(int file)
+{
+	async_exch_t *exch = vfs_exchange_begin();
+	int rc = async_req_1_0(exch, VFS_IN_PUT, file);
 	vfs_exchange_end(exch);
 	
@@ -796,9 +775,8 @@
  * @param high   If true, the received file handle will be allocated from high
  *               indices
- * @param[out] handle  Received handle.
- *
- * @return       EOK on success or an error code
- */
-errno_t vfs_receive_handle(bool high, int *handle)
+ *
+ * @return       EOK on success or a negative error code
+ */
+int vfs_receive_handle(bool high)
 {
 	ipc_callid_t callid;
@@ -813,13 +791,11 @@
 
 	sysarg_t ret;
-	errno_t rc = async_req_1_1(vfs_exch, VFS_IN_WAIT_HANDLE, high, &ret);
+	sysarg_t rc = async_req_1_1(vfs_exch, VFS_IN_WAIT_HANDLE, high, &ret);
 
 	async_exchange_end(vfs_exch);
 
-	if (rc == EOK) {
-		*handle = (int) ret;
-	}
-
-	return rc;
+	if (rc != EOK)
+		return rc;
+	return ret;
 }
 
@@ -839,10 +815,10 @@
  * @return              On failure, an error code
  */
-errno_t vfs_read(int file, aoff64_t *pos, void *buf, size_t nbyte, size_t *nread)
+int vfs_read(int file, aoff64_t *pos, void *buf, size_t nbyte, size_t *nread)
 {
 	ssize_t cnt = 0;
 	size_t nr = 0;
 	uint8_t *bp = (uint8_t *) buf;
-	errno_t rc;
+	int rc;
 	
 	do {
@@ -877,10 +853,10 @@
  * @param[out] nread	Actual number of bytes read (0 or more)
  *
- * @return              EOK on success or an error code
- */
-errno_t vfs_read_short(int file, aoff64_t pos, void *buf, size_t nbyte,
+ * @return              EOK on success or a negative error code
+ */
+int vfs_read_short(int file, aoff64_t pos, void *buf, size_t nbyte,
     ssize_t *nread)
 {
-	errno_t rc;
+	sysarg_t rc;
 	ipc_call_t answer;
 	aid_t req;
@@ -919,10 +895,10 @@
  * @param new   New path
  *
- * @return      EOK on success or an error code
- */
-errno_t vfs_rename_path(const char *old, const char *new)
-{
-	errno_t rc;
-	errno_t rc_orig;
+ * @return      EOK on success or a negative error code
+ */
+int vfs_rename_path(const char *old, const char *new)
+{
+	sysarg_t rc;
+	sysarg_t rc_orig;
 	aid_t req;
 	
@@ -986,10 +962,10 @@
  * @param length        New length
  *
- * @return              EOK on success or an error code
- */
-errno_t vfs_resize(int file, aoff64_t length)
-{
-	async_exch_t *exch = vfs_exchange_begin();
-	errno_t rc = async_req_3_0(exch, VFS_IN_RESIZE, file, LOWER32(length),
+ * @return              EOK on success or a negative error code
+ */
+int vfs_resize(int file, aoff64_t length)
+{
+	async_exch_t *exch = vfs_exchange_begin();
+	int rc = async_req_3_0(exch, VFS_IN_RESIZE, file, LOWER32(length),
 	    UPPER32(length));
 	vfs_exchange_end(exch);
@@ -1000,20 +976,16 @@
 /** Return a new file handle representing the local root
  *
- * @return      A clone of the local root file handle or -1
+ * @return      A clone of the local root file handle or a negative error code
  */
 int vfs_root(void)
 {
-	fibril_mutex_lock(&root_mutex);
-	int fd;
-	if (root_fd < 0) {
-		fd = -1;
-	} else {
-		errno_t rc = vfs_clone(root_fd, -1, true, &fd);
-		if (rc != EOK) {
-			fd = -1;
-		}
-	}
+	fibril_mutex_lock(&root_mutex);	
+	int r;
+	if (root_fd < 0)
+		r = ENOENT;
+	else
+		r = vfs_clone(root_fd, -1, true);
 	fibril_mutex_unlock(&root_mutex);
-	return fd;
+	return r;
 }
 
@@ -1025,22 +997,12 @@
  *
  * @param nroot The new local root file handle
- *
- * @return  Error code
- */
-errno_t vfs_root_set(int nroot)
-{
-	int new_root;
-	errno_t rc = vfs_clone(nroot, -1, true, &new_root);
-	if (rc != EOK) {
-		return rc;
-	}
-
+ */
+void vfs_root_set(int nroot)
+{
 	fibril_mutex_lock(&root_mutex);
 	if (root_fd >= 0)
 		vfs_put(root_fd);
-	root_fd = new_root;
+	root_fd = vfs_clone(nroot, -1, true);
 	fibril_mutex_unlock(&root_mutex);
-
-	return EOK;
 }
 
@@ -1050,9 +1012,9 @@
  * @param[out] stat     Place to store file information
  *
- * @return              EOK on success or an error code
- */
-errno_t vfs_stat(int file, vfs_stat_t *stat)
-{
-	errno_t rc;
+ * @return              EOK on success or a negative error code
+ */
+int vfs_stat(int file, struct stat *stat)
+{
+	sysarg_t rc;
 	aid_t req;
 	
@@ -1060,9 +1022,9 @@
 	
 	req = async_send_1(exch, VFS_IN_STAT, file, NULL);
-	rc = async_data_read_start(exch, (void *) stat, sizeof(vfs_stat_t));
+	rc = async_data_read_start(exch, (void *) stat, sizeof(struct stat));
 	if (rc != EOK) {
 		vfs_exchange_end(exch);
 		
-		errno_t rc_orig;
+		sysarg_t rc_orig;
 		async_wait_for(req, &rc_orig);
 		
@@ -1084,14 +1046,13 @@
  * @param[out] stat     Place to store file information
  *
- * @return              EOK on success or an error code
- */
-errno_t vfs_stat_path(const char *path, vfs_stat_t *stat)
-{
-	int file;
-	errno_t rc = vfs_lookup(path, 0, &file);
-	if (rc != EOK)
-		return rc;
-	
-	rc = vfs_stat(file, stat);
+ * @return              EOK on success or a negative error code
+ */
+int vfs_stat_path(const char *path, struct stat *stat)
+{
+	int file = vfs_lookup(path, 0);
+	if (file < 0)
+		return file;
+	
+	int rc = vfs_stat(file, stat);
 
 	vfs_put(file);
@@ -1105,9 +1066,9 @@
  * @param[out] st       Buffer for storing information
  *
- * @return              EOK on success or an error code
- */
-errno_t vfs_statfs(int file, vfs_statfs_t *st)
-{
-	errno_t rc, ret;
+ * @return              EOK on success or a negative error code
+ */
+int vfs_statfs(int file, struct statfs *st)
+{
+	sysarg_t rc, ret;
 	aid_t req;
 
@@ -1130,14 +1091,13 @@
  * @param[out] st       Buffer for storing information
  *
- * @return              EOK on success or an error code
- */
-errno_t vfs_statfs_path(const char *path, vfs_statfs_t *st)
-{
-	int file;
-	errno_t rc = vfs_lookup(path, 0, &file);
-	if (rc != EOK)
-		return rc;
-	
-	rc = vfs_statfs(file, st);
+ * @return              EOK on success or a negative error code
+ */
+int vfs_statfs_path(const char *path, struct statfs *st)
+{
+	int file = vfs_lookup(path, 0);
+	if (file < 0)
+		return file;
+	
+	int rc = vfs_statfs(file, st);
 
 	vfs_put(file);
@@ -1150,10 +1110,10 @@
  * @param file  File handle to synchronize
  *
- * @return      EOK on success or an error code
- */
-errno_t vfs_sync(int file)
-{
-	async_exch_t *exch = vfs_exchange_begin();
-	errno_t rc = async_req_1_0(exch, VFS_IN_SYNC, file);
+ * @return      EOK on success or a negative error code
+ */
+int vfs_sync(int file)
+{
+	async_exch_t *exch = vfs_exchange_begin();
+	int rc = async_req_1_0(exch, VFS_IN_SYNC, file);
 	vfs_exchange_end(exch);
 	
@@ -1172,9 +1132,9 @@
  * @param expect        File handle of the unlinked child
  *
- * @return              EOK on success or an error code
- */
-errno_t vfs_unlink(int parent, const char *child, int expect)
-{
-	errno_t rc;
+ * @return              EOK on success or a negative error code
+ */
+int vfs_unlink(int parent, const char *child, int expect)
+{
+	sysarg_t rc;
 	aid_t req;
 	
@@ -1186,9 +1146,9 @@
 	vfs_exchange_end(exch);
 	
-	errno_t rc_orig;
+	sysarg_t rc_orig;
 	async_wait_for(req, &rc_orig);
 	
 	if (rc_orig != EOK)
-		return (errno_t) rc_orig;
+		return (int) rc_orig;
 	return rc;
 }
@@ -1201,22 +1161,20 @@
  * @param path          Old path to be unlinked
  *
- * @return              EOK on success or an error code
- */
-errno_t vfs_unlink_path(const char *path)
-{
-	int expect;
-	errno_t rc = vfs_lookup(path, 0, &expect);
-	if (rc != EOK)
-		return rc;
+ * @return              EOK on success or a negative error code
+ */
+int vfs_unlink_path(const char *path)
+{
+	int expect = vfs_lookup(path, 0);
+	if (expect < 0)
+		return expect;
 
 	char *child;
-	int parent;
-	rc = get_parent_and_child(path, &parent, &child);
-	if (rc != EOK) {
+	int parent = get_parent_and_child(path, &child);
+	if (parent < 0) {
 		vfs_put(expect);
-		return rc;
-	}
-
-	rc = vfs_unlink(parent, child, expect);
+		return parent;
+	}
+
+	int rc = vfs_unlink(parent, child, expect);
 	
 	free(child);
@@ -1230,10 +1188,10 @@
  * @param mp    File handle representing the mount-point
  *
- * @return      EOK on success or an error code
- */
-errno_t vfs_unmount(int mp)
-{
-	async_exch_t *exch = vfs_exchange_begin();
-	errno_t rc = async_req_1_0(exch, VFS_IN_UNMOUNT, mp);
+ * @return      EOK on success or a negative error code
+ */
+int vfs_unmount(int mp)
+{
+	async_exch_t *exch = vfs_exchange_begin();
+	int rc = async_req_1_0(exch, VFS_IN_UNMOUNT, mp);
 	vfs_exchange_end(exch);
 	return rc;
@@ -1244,14 +1202,13 @@
  * @param mpp   Mount-point path
  *
- * @return      EOK on success or an error code
- */
-errno_t vfs_unmount_path(const char *mpp)
-{
-	int mp;
-	errno_t rc = vfs_lookup(mpp, WALK_MOUNT_POINT | WALK_DIRECTORY, &mp);
-	if (rc != EOK)
-		return rc;
-	
-	rc = vfs_unmount(mp);
+ * @return      EOK on success or a negative error code
+ */
+int vfs_unmount_path(const char *mpp)
+{
+	int mp = vfs_lookup(mpp, WALK_MOUNT_POINT | WALK_DIRECTORY);
+	if (mp < 0)
+		return mp;
+	
+	int rc = vfs_unmount(mp);
 	vfs_put(mp);
 	return rc;
@@ -1263,9 +1220,9 @@
  * @param path          Parent-relative path to be walked
  * @param flags         Flags influencing the walk
- * @param[out] handle   File handle representing the result on success.
- *
- * @return              Error code.
- */
-errno_t vfs_walk(int parent, const char *path, int flags, int *handle)
+ *
+ * @retrun              File handle representing the result on success or
+ *                      a negative error code on error
+ */
+int vfs_walk(int parent, const char *path, int flags)
 {
 	async_exch_t *exch = vfs_exchange_begin();
@@ -1273,18 +1230,17 @@
 	ipc_call_t answer;
 	aid_t req = async_send_2(exch, VFS_IN_WALK, parent, flags, &answer);
-	errno_t rc = async_data_write_start(exch, path, str_size(path));
+	sysarg_t rc = async_data_write_start(exch, path, str_size(path));
 	vfs_exchange_end(exch);
 		
-	errno_t rc_orig;
+	sysarg_t rc_orig;
 	async_wait_for(req, &rc_orig);
 
 	if (rc_orig != EOK)
-		return (errno_t) rc_orig;
+		return (int) rc_orig;
 		
 	if (rc != EOK)
-		return (errno_t) rc;
-	
-	*handle = (int) IPC_GET_ARG1(answer);
-	return EOK;
+		return (int) rc;
+	
+	return (int) IPC_GET_ARG1(answer);
 }
 
@@ -1304,5 +1260,5 @@
  * @return              On failure, an error code
  */
-errno_t vfs_write(int file, aoff64_t *pos, const void *buf, size_t nbyte,
+int vfs_write(int file, aoff64_t *pos, const void *buf, size_t nbyte,
     size_t *nwritten)
 {
@@ -1310,5 +1266,5 @@
 	ssize_t nwr = 0;
 	const uint8_t *bp = (uint8_t *) buf;
-	errno_t rc;
+	int rc;
 
 	do {
@@ -1341,10 +1297,10 @@
  * @param[out] nread    Actual number of bytes written (0 or more)
  *
- * @return              EOK on success or an error code
- */
-errno_t vfs_write_short(int file, aoff64_t pos, const void *buf, size_t nbyte,
+ * @return              EOK on success or a negative error code
+ */
+int vfs_write_short(int file, aoff64_t pos, const void *buf, size_t nbyte,
     ssize_t *nwritten)
 {
-	errno_t rc;
+	sysarg_t rc;
 	ipc_call_t answer;
 	aid_t req;
Index: uspace/lib/c/generic/vol.c
===================================================================
--- uspace/lib/c/generic/vol.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/generic/vol.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -48,9 +48,9 @@
  *             cannot be contacted.
  */
-errno_t vol_create(vol_t **rvol)
+int vol_create(vol_t **rvol)
 {
 	vol_t *vol;
 	service_id_t vol_svcid;
-	errno_t rc;
+	int rc;
 
 	vol = calloc(1, sizeof(vol_t));
@@ -101,7 +101,7 @@
  * @param act_size Place to store actual size of complete data.
  *
- * @return EOK on success or an error code.
- */
-static errno_t vol_get_ids_once(vol_t *vol, sysarg_t method, sysarg_t arg1,
+ * @return EOK on success or negative error code.
+ */
+static int vol_get_ids_once(vol_t *vol, sysarg_t method, sysarg_t arg1,
     sysarg_t *id_buf, size_t buf_size, size_t *act_size)
 {
@@ -110,5 +110,5 @@
 	ipc_call_t answer;
 	aid_t req = async_send_1(exch, method, arg1, &answer);
-	errno_t rc = async_data_read_start(exch, id_buf, buf_size);
+	int rc = async_data_read_start(exch, id_buf, buf_size);
 
 	async_exchange_end(exch);
@@ -119,5 +119,5 @@
 	}
 
-	errno_t retval;
+	sysarg_t retval;
 	async_wait_for(req, &retval);
 
@@ -139,7 +139,7 @@
  * @param data   Place to store pointer to array of IDs
  * @param count  Place to store number of IDs
- * @return       EOK on success or an error code
- */
-static errno_t vol_get_ids_internal(vol_t *vol, sysarg_t method, sysarg_t arg1,
+ * @return       EOK on success or negative error code
+ */
+static int vol_get_ids_internal(vol_t *vol, sysarg_t method, sysarg_t arg1,
     sysarg_t **data, size_t *count)
 {
@@ -148,5 +148,5 @@
 
 	size_t act_size = 0;
-	errno_t rc = vol_get_ids_once(vol, method, arg1, NULL, 0, &act_size);
+	int rc = vol_get_ids_once(vol, method, arg1, NULL, 0, &act_size);
 	if (rc != EOK)
 		return rc;
@@ -183,7 +183,7 @@
  * @param count Place to store length of array (number of entries)
  *
- * @return EOK on success or an error code
- */
-errno_t vol_get_parts(vol_t *vol, service_id_t **data, size_t *count)
+ * @return EOK on success or negative error code
+ */
+int vol_get_parts(vol_t *vol, service_id_t **data, size_t *count)
 {
 	return vol_get_ids_internal(vol, VOL_GET_PARTS, 0, data, count);
@@ -196,8 +196,8 @@
  * until it is discovered.
  */
-errno_t vol_part_add(vol_t *vol, service_id_t sid)
-{
-	async_exch_t *exch;
-	errno_t retval;
+int vol_part_add(vol_t *vol, service_id_t sid)
+{
+	async_exch_t *exch;
+	int retval;
 
 	exch = async_exchange_begin(vol->sess);
@@ -212,13 +212,13 @@
 
 /** Get partition information. */
-errno_t vol_part_info(vol_t *vol, service_id_t sid, vol_part_info_t *vinfo)
-{
-	async_exch_t *exch;
-	errno_t retval;
+int vol_part_info(vol_t *vol, service_id_t sid, vol_part_info_t *vinfo)
+{
+	async_exch_t *exch;
+	sysarg_t retval;
 	ipc_call_t answer;
 
 	exch = async_exchange_begin(vol->sess);
 	aid_t req = async_send_1(exch, VOL_PART_INFO, sid, &answer);
-	errno_t rc = async_data_read_start(exch, vinfo, sizeof(vol_part_info_t));
+	int rc = async_data_read_start(exch, vinfo, sizeof(vol_part_info_t));
 	async_exchange_end(exch);
 
@@ -237,8 +237,8 @@
 /** Erase partition (to the extent where we will consider it not containing
  * a file system. */
-errno_t vol_part_empty(vol_t *vol, service_id_t sid)
-{
-	async_exch_t *exch;
-	errno_t retval;
+int vol_part_empty(vol_t *vol, service_id_t sid)
+{
+	async_exch_t *exch;
+	int retval;
 
 	exch = async_exchange_begin(vol->sess);
@@ -253,14 +253,14 @@
 
 /** Get volume label support. */
-errno_t vol_part_get_lsupp(vol_t *vol, vol_fstype_t fstype,
+int vol_part_get_lsupp(vol_t *vol, vol_fstype_t fstype,
     vol_label_supp_t *vlsupp)
 {
 	async_exch_t *exch;
-	errno_t retval;
+	sysarg_t retval;
 	ipc_call_t answer;
 
 	exch = async_exchange_begin(vol->sess);
 	aid_t req = async_send_1(exch, VOL_PART_LSUPP, fstype, &answer);
-	errno_t rc = async_data_read_start(exch, vlsupp, sizeof(vol_label_supp_t));
+	int rc = async_data_read_start(exch, vlsupp, sizeof(vol_label_supp_t));
 	async_exchange_end(exch);
 
@@ -278,10 +278,10 @@
 
 /** Create file system. */
-errno_t vol_part_mkfs(vol_t *vol, service_id_t sid, vol_fstype_t fstype,
+int vol_part_mkfs(vol_t *vol, service_id_t sid, vol_fstype_t fstype,
     const char *label)
 {
 	async_exch_t *exch;
 	ipc_call_t answer;
-	errno_t retval;
+	sysarg_t retval;
 
 	exch = async_exchange_begin(vol->sess);
Index: uspace/lib/c/include/adt/circ_buf.h
===================================================================
--- uspace/lib/c/include/adt/circ_buf.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/adt/circ_buf.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #define LIBC_CIRC_BUF_H_
 
-#include <errno.h>
 #include <stddef.h>
 
@@ -58,6 +57,6 @@
 extern size_t circ_buf_nfree(circ_buf_t *);
 extern size_t circ_buf_nused(circ_buf_t *);
-extern errno_t circ_buf_push(circ_buf_t *, const void *);
-extern errno_t circ_buf_pop(circ_buf_t *, void *);
+extern int circ_buf_push(circ_buf_t *, const void *);
+extern int circ_buf_pop(circ_buf_t *, void *);
 
 #endif
Index: uspace/lib/c/include/adt/odict.h
===================================================================
--- uspace/lib/c/include/adt/odict.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/adt/odict.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #define LIBC_ODICT_H_
 
-#include <errno.h>
 #include <stdbool.h>
 #include <stddef.h>
@@ -62,5 +61,5 @@
 extern odlink_t *odict_find_leq(odict_t *, void *, odlink_t *);
 extern odlink_t *odict_find_lt(odict_t *, void *, odlink_t *);
-extern errno_t odict_validate(odict_t *);
+extern int odict_validate(odict_t *);
 
 #endif
Index: uspace/lib/c/include/arg_parse.h
===================================================================
--- uspace/lib/c/include/arg_parse.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/arg_parse.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,12 +36,10 @@
 #define LIBC_ARG_PARSE_H_
 
-#include <errno.h>
-
-typedef errno_t (*arg_parser)(const char *, int *);
+typedef int (*arg_parser)(const char *, int *);
 
 extern int arg_parse_short_long(const char *, const char *, const char *);
-extern errno_t arg_parse_int(int, char **, int *, int *, int);
-extern errno_t arg_parse_name_int(int, char **, int *, int *, int, arg_parser);
-extern errno_t arg_parse_string(int, char **, int *, char **, int);
+extern int arg_parse_int(int, char **, int *, int *, int);
+extern int arg_parse_name_int(int, char **, int *, int *, int, arg_parser);
+extern int arg_parse_string(int, char **, int *, char **, int);
 
 #endif
Index: uspace/lib/c/include/as.h
===================================================================
--- uspace/lib/c/include/as.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/as.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -57,9 +57,9 @@
 extern void *as_area_create(void *, size_t, unsigned int,
     as_area_pager_info_t *);
-extern errno_t as_area_resize(void *, size_t, unsigned int);
-extern errno_t as_area_change_flags(void *, unsigned int);
-extern errno_t as_area_destroy(void *);
+extern int as_area_resize(void *, size_t, unsigned int);
+extern int as_area_change_flags(void *, unsigned int);
+extern int as_area_destroy(void *);
 extern void *set_maxheapsize(size_t);
-extern errno_t as_get_physical_mapping(const void *, uintptr_t *);
+extern int as_get_physical_mapping(const void *, uintptr_t *);
 
 #endif
Index: uspace/lib/c/include/assert.h
===================================================================
--- uspace/lib/c/include/assert.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/assert.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -34,20 +34,8 @@
  */
 
-// XXX: The definition of `assert()` is not guarded.
-// One must not use `#pragma once` in this header.
-// This is in accordance with the C standard.
-
 #ifndef LIBC_ASSERT_H_
 #define LIBC_ASSERT_H_
 
 #define static_assert(expr)	_Static_assert(expr, "")
-
-extern void __helenos_assert_abort(const char *, const char *, unsigned int)
-    __attribute__((noreturn));
-
-extern void __helenos_assert_quick_abort(const char *, const char *, unsigned int)
-    __attribute__((noreturn));
-
-#endif
 
 /** Debugging assert macro
@@ -61,23 +49,22 @@
  */
 
-#undef assert
+#ifndef NDEBUG
 
-#ifndef NDEBUG
-	#define assert(expr) ((expr) ? (void) 0 : __helenos_assert_abort(#expr, __FILE__, __LINE__))
-#else
-	#define assert(expr) ((void) 0)
+#define assert(expr) \
+	do { \
+		if (!(expr)) \
+			assert_abort(#expr, __FILE__, __LINE__); \
+	} while (0)
+
+#else /* NDEBUG */
+
+#define assert(expr)
+
+#endif /* NDEBUG */
+
+extern void assert_abort(const char *, const char *, unsigned int)
+    __attribute__((noreturn));
+
 #endif
-
-#ifdef _HELENOS_SOURCE
-
-#undef safe_assert
-
-#ifndef NDEBUG
-	#define safe_assert(expr) ((expr) ? (void) 0 : __helenos_assert_quick_abort(#expr, __FILE__, __LINE__))
-#else
-	#define safe_assert(expr) ((void) 0)
-#endif
-
-#endif /* _HELENOS_SOURCE */
 
 /** @}
